<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      ref="obTable"
      is-fixed-header
      @select="onSelection"
    />
    <ob-modal
      :title="dictionaryRu.modal.title"
      ref="viewItem"
    >
      <law-articles-popup
        :data="selectedData"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import {
  CODEX_NAME,
  COUNTRY_CODE
} from '@/helpers';

import paging           from '@/mixins/dictionaries/paging';
import itemMixin        from '@/mixins/dictionaries/edit-item';

import SinglePane       from 'common-components/src/obComponents/obSinglePanels';
import ObModal          from 'common-components/src/obComponents/obModal';
import ObTable          from 'common-components/src/obComponents/obTable';
import LawArticlesPopup from './modal/index';
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__sb_dictionaries__law_articles';

export default {
  name: 'LawArticlesIndex',
  components: {
    LawArticlesPopup,
    ObModal,
    ObTable,
    SinglePane
  },
  mixins: [
    paging,
    itemMixin
  ],
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      searchValue: '',
      remoteOperations: true,
      totalCount: 0,
      selectedData: {},
      api: {
        source: '/oboz2-dictionary-law-articles-viewer/v1/'
      }
    };
  },
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: 'title'
        },
        {
          title: this.dictionaryRu.columns.codeType,
          key: 'code_type',
          alignment: 'center',
          html: function(data) {
            return CODEX_NAME(data.code_type).short;
          }
        },
        {
          title: this.dictionaryRu.columns.country,
          key: 'country_code',
          alignment: 'center',
          html: function(data) {
            return COUNTRY_CODE(data.country_code).short;
          }
        },
        {
          title: this.dictionaryRu.columns.number,
          key: 'article_number'
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          html: data => {
            return data.is_active
              ? this.dictionaryRu.status.active
              : this.dictionaryRu.status.inactive
          }
        }
      ];
    }
  }
};
</script>